SystemOrganization addCategory: 'OrbeonBPMXpdl_Tests'!

TestCase subclass: #BpmProcessGeneratorTest
	instanceVariableNames: 'processGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

BpmProcessGeneratorTest subclass: #BpmProcessGeneratorTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
getArchitectProcess

	^processGenerator getProcessDefinitionNamed: 'architect-process' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
getFixIssueProcess

	^processGenerator getProcessDefinitionNamed: 'fix-issue' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
getTestCaseProcess

	^processGenerator getProcessDefinitionNamed: 'test-case-process' ifNone: [nil]! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
setUp

	super setUp.

	processGenerator := BpmProcessGenerator exampleTestCaseFixIssueReportArchitect.! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testActivitiesNames1
	| taskNames processDefinition |

	taskNames := #('test-case' 'execute-test' 'test-ok' 'analyze-issue-report').
	processDefinition := self getTestCaseProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testActivitiesNames2
	| taskNames processDefinition |

	taskNames := #('analyze-issue' 'report-fixes' 'internal-test').
	processDefinition := self getFixIssueProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testActivitiesNames3
	| taskNames processDefinition |

	taskNames := #('analyze-developer-report' 'report-workaround' 'report-solution').
	processDefinition := self getArchitectProcess.

	(taskNames collect: [:each | processDefinition getTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfTasks)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testCreationProcess

	self assert: self getTestCaseProcess notNil.

	self assert: self getFixIssueProcess notNil.

	self assert: self getArchitectProcess notNil! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testGatewaysNames1
	| gatewaysNames processDefinition |

	gatewaysNames := #('is-issue' 'accept-issue').
	processDefinition := self getTestCaseProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testGatewaysNames2
	| gatewaysNames processDefinition |

	gatewaysNames := #('can fix').
	processDefinition := self getFixIssueProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testGatewaysNames3
	| gatewaysNames processDefinition |

	gatewaysNames := #('has-solution').
	processDefinition := self getArchitectProcess.

	(gatewaysNames collect: [:each | processDefinition getGatewayNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (gatewaysNames size = processDefinition getNumberOfGateways)! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testInTransitions1
	| process transition task1 gateway |

	process := self getTestCaseProcess.

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'test-ok' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-finished' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 06/29/2016 12:09'!
testInTransitions2
	| process transition task1 gateway |

	process := self getFixIssueProcess.

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 06/29/2016 12:09'!
testInTransitions3
	| process transition task1 gateway |

	process := self getArchitectProcess.

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getEndEventNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testLoop

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'test-case' ifNone: [self assert: false]) loop isStandart).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'test-case' ifNone: [self assert: false]) loop startQuantity = 1).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'test-case' ifNone: [self assert: false]) loop completionQuantity = 5).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'execute-test' ifNone: [self assert: false]) loop isMultiInstance).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'execute-test' ifNone: [self assert: false]) loop startQuantity = 2).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'execute-test' ifNone: [self assert: false]) loop completionQuantity = 10).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) loop isMultiInstance).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) loop startQuantity = 1).

	self assert: 
		((self getTestCaseProcess getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) loop completionQuantity = 9).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 06/29/2016 12:09'!
testOutTransitions1
	| process transition task1 gateway |

	process := self getTestCaseProcess.
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 06/29/2016 12:09'!
testOutTransitions2
	| process transition task1 gateway |

	process := self getFixIssueProcess.
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 06/29/2016 12:09'!
testOutTransitions3
	| process transition task1 gateway |

	process := self getArchitectProcess.
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (process startEvent outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testParticipants

	self assert: 
		(self getTestCaseProcess participants allSatisfy: [:each | 
			self getFixIssueProcess participants includesIdentical: each]).

	self assert:
		(self getTestCaseProcess participants size = self getFixIssueProcess participants size).

	self assert: 
		(self getTestCaseProcess participants allSatisfy: [:each | 
			self getArchitectProcess participants includesIdentical: each]).

	self assert:
		(self getTestCaseProcess participants size = self getArchitectProcess participants size).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testProcessesType

	self assert: (self getTestCaseProcess isTopProcess).

	self assert: (self getFixIssueProcess isSubProcess).

	self assert: (self getArchitectProcess isSubProcess).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testRolesResponsibility1
	| process tasks gateways subProcessTasks |

	process := self getTestCaseProcess.
	
	tasks := #('analyze-issue-report').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'test-expert'.
		self assert: isGranted].

	tasks := #('test-case').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'organizer'.
		self assert: isGranted.
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'automaticProcess'.
		self assert: isGranted].

	gateways := #('accept-issue').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'test-expert'.
		self assert: isGranted].

	tasks := #('execute-test' 'test-ok').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'tester'.
		self assert: isGranted].

	gateways := #('is-issue').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'tester'.
		self assert: isGranted].

	subProcessTasks := #('fix-issue').
	subProcessTasks do: [:each | | isGranted |
		isGranted := (process getSubProcessTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testRolesResponsibility2
	| process tasks gateways subProcessTasks |

	process := self getFixIssueProcess.

	tasks := #('analyze-issue' 'report-fixes' 'internal-test').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].

	gateways := #('can fix').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].

	subProcessTasks := #('report-to-architect').
	subProcessTasks do: [:each | | isGranted |
		isGranted := (process getSubProcessTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'developer'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testRolesResponsibility3
	| process tasks gateways |

	process := self getArchitectProcess.

	tasks := #('analyze-developer-report' 'report-solution' 'report-workaround').
	tasks do: [:each | | isGranted |
		isGranted := (process getTaskNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'architect'.
		self assert: isGranted].

	gateways := #('has-solution').
	gateways do: [:each | | isGranted |
		isGranted := (process getGatewayNamed: each ifNone: [self assert: false]) isGrantedRoleNamed: 'architect'.
		self assert: isGranted].! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testSubProcessesConnection

	self assert: (((self getTestCaseProcess getSubProcessTaskNamed: 'fix-issue' ifNone: [self assert: false]) subProcessDefinition 
							== self getFixIssueProcess)).

	self assert: (((self getFixIssueProcess getSubProcessTaskNamed: 'report-to-architect' ifNone: [self assert: false]) subProcessDefinition == self getArchitectProcess)).! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testTransitionAcceptIssueCondition1
	| process transition |

	process := self getTestCaseProcess.

	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form acceptOrReject = ''accept'']').


	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form acceptOrReject = ''reject'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testTransitionCanFixCondition2
	| process transition |

	process := self getFixIssueProcess.

	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form developerCanFix = ''yes'']').


	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form developerCanFix = ''no'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testTransitionHasSolutionCondition3
	| process transition |

	process := self getArchitectProcess.

	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form hasSolution = ''no'']').


	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form hasSolution = ''yes'']')! !

!BpmProcessGeneratorTest1 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testTransitionIsIssueCondition1
	| process transition |

	process := self getTestCaseProcess.

	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form result = ''failed'']').


	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (transition conditionToRun evaluationCode = '[:form | form result ~= ''failed'']')! !

BpmProcessGeneratorTest subclass: #BpmProcessGeneratorTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

!BpmProcessGeneratorTest2 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
getScriptProcess

	^processGenerator getProcessDefinitionNamed: 'Process with Scripts' ifNone: [nil]! !

!BpmProcessGeneratorTest2 methodsFor: 'Accessing' stamp: 'BrunoBB 06/29/2016 12:09'!
processGenerator
	^processGenerator! !

!BpmProcessGeneratorTest2 methodsFor: 'Updating' stamp: 'BrunoBB 06/29/2016 12:09'!
processGenerator: newValue
	processGenerator := newValue! !

!BpmProcessGeneratorTest2 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
setUp

	super setUp.

	processGenerator := BpmProcessGenerator exampleTestCaseProcessWithScript.! !

!BpmProcessGeneratorTest2 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:09'!
testActivitiesNames
	| taskNames processDefinition |

	taskNames := #('script').
	processDefinition := self getScriptProcess.

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	self assert: (taskNames size = processDefinition getNumberOfScripts).! !

BpmProcessGeneratorTest subclass: #BpmProcessGeneratorTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:46'!
getEmbeddedSubProcess

	^processGenerator getProcessDefinitionNamed: 'embedded-sub-proc' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:45'!
getReusableSubProcess

	^processGenerator getProcessDefinitionNamed: 'Reusable-Script' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:45'!
getTopProcess

	^processGenerator getProcessDefinitionNamed: 'ReusableEmbeddedProc' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:12'!
setUp

	super setUp.

	processGenerator := BpmProcessGenerator exampleTestCaseEmbeddedSubProc.! !

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:48'!
testActivitiesNames
	| taskNames processDefinition |

	taskNames := #('script').
	processDefinition := self getTopProcess.

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	taskNames := #('embedded-sub-proc' 'reusabe-sub-proc').
	(taskNames collect: [:each | processDefinition getSubProcessTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	processDefinition := self getReusableSubProcess.
	taskNames := #('script-reusable').

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	processDefinition := self getEmbeddedSubProcess.
	taskNames := #('script-embedded').

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].! !

!BpmProcessGeneratorTest3 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:01'!
testSubProcess
	| processDefinition |

	processDefinition := self getTopProcess.

	self assert: ((processDefinition getSubProcessTaskNamed: 'embedded-sub-proc' ifNone: [self assert: false]) subProcessDefinition 
						== self getEmbeddedSubProcess).

	self assert: ((processDefinition getSubProcessTaskNamed: 'reusabe-sub-proc' ifNone: [self assert: false]) subProcessDefinition 
						== self getReusableSubProcess).! !

BpmProcessGeneratorTest subclass: #BpmProcessGeneratorTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl_Tests'!

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:55'!
getEmbedded01Process

	^processGenerator getProcessDefinitionNamed: 'embedded 01' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:55'!
getEmbedded02Process

	^processGenerator getProcessDefinitionNamed: 'embedded 02' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:55'!
getTopProcess

	^processGenerator getProcessDefinitionNamed: 'multi-embedded' ifNone: [self assert: false]! !

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:54'!
setUp

	super setUp.

	processGenerator := BpmProcessGenerator exampleEmbeddedSubProcSubProc.! !

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:58'!
testActivitiesNames
	| taskNames processDefinition |

	taskNames := #('script').
	processDefinition := self getTopProcess.

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	taskNames := #('embedded 01').
	(taskNames collect: [:each | processDefinition getSubProcessTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	processDefinition := self getEmbedded01Process.
	taskNames := #('script-embedded-01').

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	taskNames := #('embedded 02').
	(taskNames collect: [:each | processDefinition getSubProcessTaskNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].

	processDefinition := self getEmbedded02Process.
	taskNames := #('script-embedded-02').

	(taskNames collect: [:each | processDefinition getScriptNamed: each ifNone: [nil]])
		do: [:each | self assert: each notNil].! !

!BpmProcessGeneratorTest4 methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 12:03'!
testSubProcess
	| processDefinition |

	processDefinition := self getTopProcess.

	self assert: ((processDefinition getSubProcessTaskNamed: 'embedded 01' ifNone: [self assert: false]) subProcessDefinition 
						== self getEmbedded01Process).


	processDefinition := self getEmbedded01Process.
	self assert: ((processDefinition getSubProcessTaskNamed: 'embedded 02' ifNone: [self assert: false]) subProcessDefinition 
						== self getEmbedded02Process).! !
